# ASP.NET
# Build and test ASP.NET projects.
# Add steps that publish symbols, save build artifacts, deploy, and more:
# https://docs.microsoft.com/azure/devops/pipelines/apps/aspnet/build-aspnet-4

trigger:
- none

pool:
  vmImage: 'ubuntu-latest'

variables:
  - group: JustGo variable group

resources:
  repositories:
    - repository: templates
      type: git
      name: JustGo/zzz
stages:
- stage: Validation
  jobs:
  - job: waitForValidation
    displayName: Wait for external validation
    pool: server
    timeoutInMinutes: 4320 # job times out in 3 days
    steps:
    - task: ManualValidation@0
      timeoutInMinutes: 1440 # task times out in 1 day
      inputs:
        notifyUsers: |
          akash.paul@azolve.com
        instructions: 'Please validate the build configuration and resume'
        onTimeout: 'resume'
  - job: normaltask
    displayName: Deployment Task    
    dependsOn: waitForValidation    
    timeoutInMinutes: 360 # job times out 0 for unlimited    
    steps:
    - powershell: |
       az login -u $(user) -p $(pass)
   
      displayName: 'Azure Login'
      enabled: true
    - template: Deployment.yml@templates
  
    - powershell: |
         $body = @"
         <html><head></head><body><div class="m_-6878574263037130521container" style="font-family:'Segoe UI','-apple-system','BlinkMacSystemFont','Roboto','Arial',sans-serif;color:#212121;font-size:14px;background:#f8f8f8">
         <table border="0" cellpadding="0" cellspacing="0" width="100%">
             <tbody><tr>
                 <td class="m_-6878574263037130521mobile-hide" style="background-color:white;border-bottom:solid #eaeaea 1px"></td>
                 <td class="m_-6878574263037130521content" width="640" style="padding:0px;max-width:640px;background-color:white;border-bottom:solid #eaeaea 1px">
                     <table border="0" cellpadding="0" cellspacing="0" width="100%">       
         <tbody><tr>
             <td style="padding:20px 24px 25px 24px;background:white">
                 <table border="0" cellpadding="0" cellspacing="0" width="100%" class="m_-6878574263037130521responsive-table">
                     <tbody><tr>
                         <td>
                             <table border="0" cellpadding="0" cellspacing="0" class="m_-6878574263037130521logo" width="100%">
                                 <tbody><tr>
                                     <td valign="middle" style="vertical-align:middle">
                                         <img alt="JustGo" height="30" src="https://i.postimg.cc/XNQ93Gwf/Just-Go-Logo-200x40px.png" width="150" class="CToWUd">
                                     </td>
                                         <td valign="middle" style="word-wrap:none;vertical-align:middle;text-align:right">
                                             <span style="color:#666666">Azure</span> <span style="color:#0078d4;font-weight:bold">DevOps</span>
                                         </td>
                                 </tr>
                             </tbody></table>
                         </td>
                     </tr>
                 </tbody></table>
             </td>
         </tr>
         <tr>
         <td style="padding:0px 24px">
         <table border="0" cellpadding="0" cellspacing="0" width="100%" style="max-width:592px" class="m_-6878574263037130521responsive-table">
           <tbody><tr>
             <td>
               <table width="100%" border="0" cellspacing="0" cellpadding="0">
                 <tbody><tr>
                   <td>
                     <table>
                       <tbody><tr>
                         <td style="padding:0 0 24px 0">
             <table border="0" cellpadding="0" cellspacing="0" style="vertical-align:middle">
                 <tbody><tr>                                                              
                                     <td style="padding-right:7px" valign="top"><img src="https://ci5.googleusercontent.com/proxy/fCqHcSp0qoVpCTytf373739iAaP4gR5MRODWBPCMZraHj8r_2K9NAkOzZljt_BFppQVN9lU-mdyEZ07yroXHIzEkykzHIXMlt8e3aLyDt8-0_sAX=s0-d-e1-ft#https://cdn.vsassets.io/content/notifications/icon-success-20.png" width="20" height="20" class="m_-6878574263037130521img-block CToWUd"></td>
                                     <td valign="middle" style="font-size:13px;font-weight:800;line-height:20px;color:#00b14b;font-family:Segoe UI,Helvetica,Arial,sans-serif;padding-top:0px;vertical-align:middle;text-transform:uppercase">Patch Pipeline #$(Build.BuildNumber) succeeded</td>

                 </tr>
             </tbody></table>
                         </td>
                       </tr>
                           <tr>
                             <td class="m_-6878574263037130521title" style="padding:0 0 24px 0;color:#212121;font-size:28px;font-weight:bold;letter-spacing:-0.04em;line-height:40px;word-break:break-word">
                               For $(Build.SourceBranchName)
                             </td>
                           </tr>
                       <tr>
                         <td style="padding:0 0 24px 0">
                             <pre style="white-space:pre-wrap;display:inline;font-family:'Segoe UI','-apple-system','BlinkMacSystemFont','Roboto','Arial',sans-serif;padding:0px;margin:0px;font-size:14px;line-height:20px;color:#444444;word-break:break-word">Agent is $(Agent.Name)</pre>
                        </td>
                       </tr>
                       <tr>
                         <td style="padding:0 0 24px 0">
         <table width="100%" border="0" cellspacing="0" cellpadding="0">
           <tbody><tr>
             <td>
               <table border="0" cellspacing="0" cellpadding="0">
                 <tbody><tr>
                       <td align="center" bgcolor="#007acc" style="padding:8px 12px;border-radius:2px">
                         <a href="https://dev.azure.com/azolvedevops/JustGo/_build/results?buildId=$(Build.BuildId)&amp;view=logs&amp;s=96ac2280-8cb4-5df5-99de-dd2da759617d" style="font-weight:500;font-size:14px;text-decoration:none;padding:0px;display:inline-block;color:#ffffff" class="m_-6878574263037130521mobile-button m_-6878574263037130521btn-primary" target="_blank" data-saferedirecturl="https://www.google.com/url?q=https://dev.azure.com/azolvedevops/web/build.aspx?pcguid%3Da6ab4fda-c24b-4ee9-9152-b0023b559042%26builduri%3Dvstfs%253a%252f%252f%252fBuild%252fBuild%252f1847%26tracking_data%3DeyJTb3VyY2UiOiJFbWFpbCIsIlR5cGUiOiJOb3RpZmljYXRpb24iLCJTSUQiOiJtcy52c3MtYnVpbGQuYnVpbGQtcmVxdWVzdGVkLXBlcnNvbmFsLXN1YnNjcmlwdGlvbiIsIlNUeXBlIjoiQ09OIiwiUmVjaXAiOjEsIl94Y2kiOnsiTklEIjo2ODgyNzMxNiwiTVJlY2lwIjoibTA9MSAiLCJBY3QiOiIyZTNmODU2ZS02MDgxLTRiYTItYjIxNS1jMmM1YjVjZjQzOTEifSwiRWxlbWVudCI6Imhlcm8vY3RhIn0%253d&amp;source=gmail&amp;ust=1640769366366000&amp;usg=AOvVaw1mhZh09CteEYy-m0E2I84F">
                           View results
                         </a>
                       </td>
                 </tr>
               </tbody></table>
             </td>
           </tr>
         </tbody></table>
                         </td>
                       </tr>
                     </tbody></table>
                   </td>
                 </tr>
               </tbody></table>
             </td>
           </tr>
         </tbody></table>
         </td>
         </tr>
                     </tbody></table>
                 </td>
                 <td class="m_-6878574263037130521mobile-hide" style="background-color:white;border-bottom:solid #eaeaea 1px"></td>
             </tr>
             <tr>
                 <td class="m_-6878574263037130521mobile-hide" style="background:#f8f8f8"></td>
                 <td class="m_-6878574263037130521content" width="640" style="padding:0px;max-width:640px;background:#f8f8f8">
                     <table border="0" cellpadding="0" cellspacing="0" width="100%">            
                                     <tbody><tr>
                                         <td style="padding:24px 24px 8px 24px;max-width:592px">
             <table border="0" width="100%" cellpadding="0" cellspacing="0" style="vertical-align:middle;background-color:white" class="m_-6878574263037130521responsive-table">
                 <tbody><tr>
                     <td style="padding:16px 24px 24px 24px">
                     <table width="100%" border="0" cellspacing="0" cellpadding="0">
                         <tbody><tr>
                             <td style="font-size:21px;line-height:25px;font-weight:600;letter-spacing:-0.04em;padding:0px;width:100%">
                                     Summary
                                                     </td>
                         </tr>
                         <tr>
                             <td style="padding:12px 0px 0px 0px;line-height:20px;max-width:544px">
                                         <table border="0" cellpadding="0" cellspacing="0" style="width:100%;border-collapse:collapse!important">
         <tbody><tr>            <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap;font-weight:600;min-width:130px">Pipeline</td>
                     <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:normal;width:99%;word-break:break-word">$(Build.DefinitionName)</td>
         </tr>        <tr>
                     <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap;font-weight:600;min-width:130px">Finished</td>
                     <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:normal;width:99%;word-break:break-word">$(Get-Date -Format g) GMT+00:00</td>
         </tr>        
         <tr>                <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap;font-weight:600;min-width:130px">Requested for</td>
                         <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:normal;width:99%;word-break:break-word">$(Build.RequestedFor)</td>
         </tr>        
         <tr>            <td style="vertical-align:top;padding:10px 4px;border-bottom:none;text-align:left;white-space:nowrap;font-weight:600;min-width:130px">Reason</td>
                     <td style="vertical-align:top;padding:10px 4px;border-bottom:none;text-align:left;white-space:normal;width:99%;word-break:break-word">$(Build.Reason)</td>
         </tr>    </tbody></table>
                             </td>
                         </tr>
                     </tbody></table>
                 </td>
             </tr>
         </tbody></table>
                                         </td>
                                     </tr>
                                     <tr>
                                         <td style="padding:24px 24px 8px 24px;max-width:592px">
             <table border="0" width="100%" cellpadding="0" cellspacing="0" style="vertical-align:middle;background-color:white" class="m_-6878574263037130521responsive-table">
                 <tbody><tr>
                     <td style="padding:16px 24px 24px 24px">      
             <table border="0" width="100%" cellpadding="0" cellspacing="0" style="vertical-align:middle;background-color:white" class="m_-6878574263037130521responsive-table">
                 <tbody><tr>
                     <td style="padding:16px 24px 24px 24px">
                     <table width="100%" border="0" cellspacing="0" cellpadding="0">
                         <tbody><tr>
                             <td style="font-size:21px;line-height:25px;font-weight:600;letter-spacing:-0.04em;padding:0px;width:100%">
                                     Commit
                                                     </td>
                         </tr>
                         <tr>
                             <td style="padding:12px 0px 0px 0px;line-height:20px;max-width:544px">
                                         <table border="0" cellpadding="0" cellspacing="0" style="width:100%;border-collapse:collapse!important">
                 <tbody><tr>
         <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap">                <a href="https://dev.azure.com/azolvedevops/43c49014-d566-49f1-a3ef-658d41d70222/_git/9ea87984-08aa-40ab-8adb-54385e62d99a/commit/$(Build.SourceVersion)" target="_blank" data-saferedirecturl="https://www.google.com/url?q=https://dev.azure.com/azolvedevops/43c49014-d566-49f1-a3ef-658d41d70222/_git/9ea87984-08aa-40ab-8adb-54385e62d99a/commit/$(Build.SourceVersion)&amp;source=gmail&amp;ust=1640769366366000&amp;usg=AOvVaw0SsVZYi2MoIYexVtLKzJjp"><span class="m_-6878574263037130521monospaced">$(Build.SourceVersion)</span></a>
         </td>            <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:normal;width:99%;word-break:break-word">
                         $(Build.SourceVersionMessage)
                         <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap">
                         Branch $(Build.SourceBranchName)
         </td>
         </td>            
         </div>
         </body></html>
         "@
         $secpasswd = ConvertTo-SecureString "$(mail_pass)" -AsPlainText -Force
         $cred = New-Object System.Management.Automation.PSCredential ("akash.paul@justgo.com", $secpasswd)
         Send-MailMessage -SmtpServer smtp.gmail.com -Credential $cred -UseSsl -From 'akash.paul@justgo.com' -To 'akash.paul@justgo.com' -Subject 'Patch Pipeline Success - $(Build.DefinitionName)' -Body $body -BodyAsHtml
         Continue
  
      displayName: 'Success email'
      enabled: true
      errorActionPreference: default
      failOnStderr: true
      ignoreLASTEXITCODE: true
      condition: eq(variables['Agent.JobStatus'], 'Succeeded')

    - powershell: |
         $body = @"
         <html><head></head><body><div class="m_-6878574263037130521container" style="font-family:'Segoe UI','-apple-system','BlinkMacSystemFont','Roboto','Arial',sans-serif;color:#212121;font-size:14px;background:#f8f8f8">
         <table border="0" cellpadding="0" cellspacing="0" width="100%">
             <tbody><tr>
                 <td class="m_-6878574263037130521mobile-hide" style="background-color:white;border-bottom:solid #eaeaea 1px"></td>
                 <td class="m_-6878574263037130521content" width="640" style="padding:0px;max-width:640px;background-color:white;border-bottom:solid #eaeaea 1px">
                     
                     
                     <table border="0" cellpadding="0" cellspacing="0" width="100%">               
         <tbody><tr>
             <td style="padding:20px 24px 25px 24px;background:white">
                 <table border="0" cellpadding="0" cellspacing="0" width="100%" class="m_-6878574263037130521responsive-table">
                     <tbody><tr>
                         <td>
                             <table border="0" cellpadding="0" cellspacing="0" class="m_-6878574263037130521logo" width="100%">
                                 <tbody><tr>
                                     <td valign="middle" style="vertical-align:middle">
                                         <img alt="JustGo" height="30" src="https://i.postimg.cc/XNQ93Gwf/Just-Go-Logo-200x40px.png" width="150" class="CToWUd">
                                     </td>
                                         <td valign="middle" style="word-wrap:none;vertical-align:middle;text-align:right">
                                             <span style="color:#666666">Azure</span> <span style="color:#0078d4;font-weight:bold">DevOps</span>
                                         </td>
                                 </tr>
                             </tbody></table>
                         </td>
                     </tr>
                 </tbody></table>
             </td>
         </tr>
         <tr>
         <td style="padding:0px 24px">
         <table border="0" cellpadding="0" cellspacing="0" width="100%" style="max-width:592px" class="m_-6878574263037130521responsive-table">
           <tbody><tr>
             <td>
               <table width="100%" border="0" cellspacing="0" cellpadding="0">
                 <tbody><tr>
                   <td>
                     <table>
                       <tbody><tr>
                         <td style="padding:0 0 24px 0">
             <table border="0" cellpadding="0" cellspacing="0" style="vertical-align:middle">
                 <tbody><tr>                                                   
                                     <td style="padding-right:7px" valign="top"><img src="https://ci5.googleusercontent.com/proxy/bYYIEH2lZh5Gpyv0a9-8WPkjQIvjxGeoRvKmGLQgRvxd6MyqBgDAheB5yzVHqY8EZzgw8L0vQhEgb1HpLANCpbSF7VcTxjqkJyBEsQNZCXW62K1w=s0-d-e1-ft#https://cdn.vsassets.io/content/notifications/icon-failure-20.png" width="20" height="20" class="m_-6878574263037130521img-block CToWUd"></td>
                                     <td valign="middle" style="font-size:13px;font-weight:800;line-height:20px;color:#ff4743;font-family:Segoe UI,Helvetica,Arial,sans-serif;padding-top:0px;vertical-align:middle;text-transform:uppercase">Patch Pipeline #$(Build.BuildNumber) failed</td>

                 </tr>
             </tbody></table>
                         </td>
                       </tr>
                           <tr>
                             <td class="m_-6878574263037130521title" style="padding:0 0 24px 0;color:#212121;font-size:28px;font-weight:bold;letter-spacing:-0.04em;line-height:40px;word-break:break-word">
                               For $(Build.SourceBranchName)
                             </td>
                           </tr>
                       <tr>
                         <td style="padding:0 0 24px 0">
                             <pre style="white-space:pre-wrap;display:inline;font-family:'Segoe UI','-apple-system','BlinkMacSystemFont','Roboto','Arial',sans-serif;padding:0px;margin:0px;font-size:14px;line-height:20px;color:#444444;word-break:break-word">Agent is $(Agent.Name)</pre>
                        </td>
                       </tr>
                       <tr>
                         <td style="padding:0 0 24px 0">
         <table width="100%" border="0" cellspacing="0" cellpadding="0">
           <tbody><tr>
             <td>
               <table border="0" cellspacing="0" cellpadding="0">
                 <tbody><tr>
                       <td align="center" bgcolor="#007acc" style="padding:8px 12px;border-radius:2px">
                         <a href="https://dev.azure.com/azolvedevops/JustGo/_build/results?buildId=$(Build.BuildId)&amp;view=logs&amp;s=96ac2280-8cb4-5df5-99de-dd2da759617d" style="font-weight:500;font-size:14px;text-decoration:none;padding:0px;display:inline-block;color:#ffffff" class="m_-6878574263037130521mobile-button m_-6878574263037130521btn-primary" target="_blank" data-saferedirecturl="https://www.google.com/url?q=https://dev.azure.com/azolvedevops/web/build.aspx?pcguid%3Da6ab4fda-c24b-4ee9-9152-b0023b559042%26builduri%3Dvstfs%253a%252f%252f%252fBuild%252fBuild%252f1847%26tracking_data%3DeyJTb3VyY2UiOiJFbWFpbCIsIlR5cGUiOiJOb3RpZmljYXRpb24iLCJTSUQiOiJtcy52c3MtYnVpbGQuYnVpbGQtcmVxdWVzdGVkLXBlcnNvbmFsLXN1YnNjcmlwdGlvbiIsIlNUeXBlIjoiQ09OIiwiUmVjaXAiOjEsIl94Y2kiOnsiTklEIjo2ODgyNzMxNiwiTVJlY2lwIjoibTA9MSAiLCJBY3QiOiIyZTNmODU2ZS02MDgxLTRiYTItYjIxNS1jMmM1YjVjZjQzOTEifSwiRWxlbWVudCI6Imhlcm8vY3RhIn0%253d&amp;source=gmail&amp;ust=1640769366366000&amp;usg=AOvVaw1mhZh09CteEYy-m0E2I84F">
                           View results
                         </a>
                       </td>
                 </tr>
               </tbody></table>
             </td>
           </tr>
         </tbody></table>
                         </td>
                       </tr>
                     </tbody></table>
                   </td>
                 </tr>
               </tbody></table>
             </td>
           </tr>
         </tbody></table>
         </td>
         </tr>
                     </tbody></table>
                 </td>
                 <td class="m_-6878574263037130521mobile-hide" style="background-color:white;border-bottom:solid #eaeaea 1px"></td>
             </tr>
             <tr>
                 <td class="m_-6878574263037130521mobile-hide" style="background:#f8f8f8"></td>
                 <td class="m_-6878574263037130521content" width="640" style="padding:0px;max-width:640px;background:#f8f8f8">
                     <table border="0" cellpadding="0" cellspacing="0" width="100%">            
                                     <tbody><tr>
                                         <td style="padding:24px 24px 8px 24px;max-width:592px">
             <table border="0" width="100%" cellpadding="0" cellspacing="0" style="vertical-align:middle;background-color:white" class="m_-6878574263037130521responsive-table">
                 <tbody><tr>
                     <td style="padding:16px 24px 24px 24px">
                     <table width="100%" border="0" cellspacing="0" cellpadding="0">
                         <tbody><tr>
                             <td style="font-size:21px;line-height:25px;font-weight:600;letter-spacing:-0.04em;padding:0px;width:100%">
                                     Summary
                                                     </td>
                         </tr>
                         <tr>
                             <td style="padding:12px 0px 0px 0px;line-height:20px;max-width:544px">
                                         <table border="0" cellpadding="0" cellspacing="0" style="width:100%;border-collapse:collapse!important">
         <tbody><tr>            <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap;font-weight:600;min-width:130px">Pipeline</td>
                     <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:normal;width:99%;word-break:break-word">$(Build.DefinitionName)</td>
         </tr>        <tr>
                     <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap;font-weight:600;min-width:130px">Finished</td>
                     <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:normal;width:99%;word-break:break-word">$(Get-Date -Format g) GMT+00:00</td>
         </tr>        
         <tr>                <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap;font-weight:600;min-width:130px">Requested for</td>
                         <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:normal;width:99%;word-break:break-word">$(Build.RequestedFor)</td>
         </tr>        
         <tr>            <td style="vertical-align:top;padding:10px 4px;border-bottom:none;text-align:left;white-space:nowrap;font-weight:600;min-width:130px">Reason</td>
                     <td style="vertical-align:top;padding:10px 4px;border-bottom:none;text-align:left;white-space:normal;width:99%;word-break:break-word">$(Build.Reason)</td>
         </tr>    </tbody></table>
                             </td>
                         </tr>
                     </tbody></table>
                 </td>
             </tr>
         </tbody></table>
                                         </td>
                                     </tr>
                                     <tr>
                                         <td style="padding:24px 24px 8px 24px;max-width:592px">
             <table border="0" width="100%" cellpadding="0" cellspacing="0" style="vertical-align:middle;background-color:white" class="m_-6878574263037130521responsive-table">
                 <tbody><tr>
                     <td style="padding:16px 24px 24px 24px">   
             <table border="0" width="100%" cellpadding="0" cellspacing="0" style="vertical-align:middle;background-color:white" class="m_-6878574263037130521responsive-table">
                 <tbody><tr>
                     <td style="padding:16px 24px 24px 24px">
                     <table width="100%" border="0" cellspacing="0" cellpadding="0">
                         <tbody><tr>
                             <td style="font-size:21px;line-height:25px;font-weight:600;letter-spacing:-0.04em;padding:0px;width:100%">
                                     Commit
                                                     </td>
                         </tr>
                         <tr>
                             <td style="padding:12px 0px 0px 0px;line-height:20px;max-width:544px">
                                         <table border="0" cellpadding="0" cellspacing="0" style="width:100%;border-collapse:collapse!important">
                 <tbody><tr>
         <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap">                <a href="https://dev.azure.com/azolvedevops/43c49014-d566-49f1-a3ef-658d41d70222/_git/9ea87984-08aa-40ab-8adb-54385e62d99a/commit/$(Build.SourceVersion)" target="_blank" data-saferedirecturl="https://www.google.com/url?q=https://dev.azure.com/azolvedevops/43c49014-d566-49f1-a3ef-658d41d70222/_git/9ea87984-08aa-40ab-8adb-54385e62d99a/commit/$(Build.SourceVersion)&amp;source=gmail&amp;ust=1640769366366000&amp;usg=AOvVaw0SsVZYi2MoIYexVtLKzJjp"><span class="m_-6878574263037130521monospaced">$(Build.SourceVersion)</span></a>
         </td>            <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:normal;width:99%;word-break:break-word">
                         $(Build.SourceVersionMessage)
                         <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap">
                         Branch $(Build.SourceBranchName)
         </td>
         </td>            
         </div>
         </body></html>
         "@
         $secpasswd = ConvertTo-SecureString "$(mail_pass)" -AsPlainText -Force
         $cred = New-Object System.Management.Automation.PSCredential ("akash.paul@justgo.com", $secpasswd)
         Send-MailMessage -SmtpServer smtp.gmail.com -Credential $cred -UseSsl -From 'akash.paul@justgo.com' -To 'akash.paul@justgo.com' -Subject 'Patch Pipeline Failed - $(Build.DefinitionName)' -Body $body -BodyAsHtml
         Continue
  
      displayName: 'Failure email'
      enabled: true
      errorActionPreference: default
      failOnStderr: true
      ignoreLASTEXITCODE: true
      condition: eq(variables['Agent.JobStatus'], 'Failed')

    - powershell: |
         $body = @"
         <html><head></head><body><div class="m_-6878574263037130521container" style="font-family:'Segoe UI','-apple-system','BlinkMacSystemFont','Roboto','Arial',sans-serif;color:#212121;font-size:14px;background:#f8f8f8">
         <table border="0" cellpadding="0" cellspacing="0" width="100%">
             <tbody><tr>
                 <td class="m_-6878574263037130521mobile-hide" style="background-color:white;border-bottom:solid #eaeaea 1px"></td>
                 <td class="m_-6878574263037130521content" width="640" style="padding:0px;max-width:640px;background-color:white;border-bottom:solid #eaeaea 1px">
                     <table border="0" cellpadding="0" cellspacing="0" width="100%">           
         <tbody><tr>
             <td style="padding:20px 24px 25px 24px;background:white">
                 <table border="0" cellpadding="0" cellspacing="0" width="100%" class="m_-6878574263037130521responsive-table">
                     <tbody><tr>
                         <td>
                             <table border="0" cellpadding="0" cellspacing="0" class="m_-6878574263037130521logo" width="100%">
                                 <tbody><tr>
                                     <td valign="middle" style="vertical-align:middle">
                                         <img alt="JustGo" height="30" src="https://i.postimg.cc/XNQ93Gwf/Just-Go-Logo-200x40px.png" width="150" class="CToWUd">
                                     </td>
                                         <td valign="middle" style="word-wrap:none;vertical-align:middle;text-align:right">
                                             <span style="color:#666666">Azure</span> <span style="color:#0078d4;font-weight:bold">DevOps</span>
                                         </td>
                                 </tr>
                             </tbody></table>
                         </td>
                     </tr>
                 </tbody></table>
             </td>
         </tr>
         <tr>
         <td style="padding:0px 24px">
         <table border="0" cellpadding="0" cellspacing="0" width="100%" style="max-width:592px" class="m_-6878574263037130521responsive-table">
           <tbody><tr>
             <td>
               <table width="100%" border="0" cellspacing="0" cellpadding="0">
                 <tbody><tr>
                   <td>
                     <table>
                       <tbody><tr>
                         <td style="padding:0 0 24px 0">      
             <table border="0" cellpadding="0" cellspacing="0" style="vertical-align:middle">
                 <tbody><tr>                                                 
                                     <td style="padding-right:7px" valign="top"><img src="https://ci4.googleusercontent.com/proxy/Dl7Gwx8_6INk80CIQoeVvcqV4LlED3LEFyJWDfDsY8NKXlgyjGUSP7g9eNX1cQ1n7ej7JWvysnCHzqDKLMQFjpinlZcUPoN-G-dwLz7OfFanXuwy=s0-d-e1-ft#https://cdn.vsassets.io/content/notifications/icon-warning-20.png" width="20" height="20" class="m_-6878574263037130521img-block CToWUd"></td>
                                     <td valign="middle" style="font-size:13px;font-weight:800;line-height:20px;color:#f8a800;font-family:Segoe UI,Helvetica,Arial,sans-serif;padding-top:0px;vertical-align:middle;text-transform:uppercase">Patch Pipeline #$(Build.BuildNumber) PARTIALLY SUCCEEDED</td>

                 </tr>
             </tbody></table>
                         </td>
                       </tr>
                           <tr>
                             <td class="m_-6878574263037130521title" style="padding:0 0 24px 0;color:#212121;font-size:28px;font-weight:bold;letter-spacing:-0.04em;line-height:40px;word-break:break-word">
                               For $(Build.SourceBranchName)
                             </td>
                           </tr>
                       <tr>
                         <td style="padding:0 0 24px 0">
                             <pre style="white-space:pre-wrap;display:inline;font-family:'Segoe UI','-apple-system','BlinkMacSystemFont','Roboto','Arial',sans-serif;padding:0px;margin:0px;font-size:14px;line-height:20px;color:#444444;word-break:break-word">Agent is $(Agent.Name)</pre>
                        </td>
                       </tr>
                       <tr>
                         <td style="padding:0 0 24px 0">
         <table width="100%" border="0" cellspacing="0" cellpadding="0">
           <tbody><tr>
             <td>
               <table border="0" cellspacing="0" cellpadding="0">
                 <tbody><tr>
                       <td align="center" bgcolor="#007acc" style="padding:8px 12px;border-radius:2px">
                         <a href="https://dev.azure.com/azolvedevops/JustGo/_build/results?buildId=$(Build.BuildId)&amp;view=logs&amp;s=96ac2280-8cb4-5df5-99de-dd2da759617d" style="font-weight:500;font-size:14px;text-decoration:none;padding:0px;display:inline-block;color:#ffffff" class="m_-6878574263037130521mobile-button m_-6878574263037130521btn-primary" target="_blank" data-saferedirecturl="https://www.google.com/url?q=https://dev.azure.com/azolvedevops/web/build.aspx?pcguid%3Da6ab4fda-c24b-4ee9-9152-b0023b559042%26builduri%3Dvstfs%253a%252f%252f%252fBuild%252fBuild%252f1847%26tracking_data%3DeyJTb3VyY2UiOiJFbWFpbCIsIlR5cGUiOiJOb3RpZmljYXRpb24iLCJTSUQiOiJtcy52c3MtYnVpbGQuYnVpbGQtcmVxdWVzdGVkLXBlcnNvbmFsLXN1YnNjcmlwdGlvbiIsIlNUeXBlIjoiQ09OIiwiUmVjaXAiOjEsIl94Y2kiOnsiTklEIjo2ODgyNzMxNiwiTVJlY2lwIjoibTA9MSAiLCJBY3QiOiIyZTNmODU2ZS02MDgxLTRiYTItYjIxNS1jMmM1YjVjZjQzOTEifSwiRWxlbWVudCI6Imhlcm8vY3RhIn0%253d&amp;source=gmail&amp;ust=1640769366366000&amp;usg=AOvVaw1mhZh09CteEYy-m0E2I84F">
                           View results
                         </a>
                       </td>
                 </tr>
               </tbody></table>
             </td>
           </tr>
         </tbody></table>
                         </td>
                       </tr>
                     </tbody></table>
                   </td>
                 </tr>
               </tbody></table>
             </td>
           </tr>
         </tbody></table>
         
         </td>
         </tr>
                     </tbody></table>
                 </td>
                 <td class="m_-6878574263037130521mobile-hide" style="background-color:white;border-bottom:solid #eaeaea 1px"></td>
             </tr>
             <tr>
                 <td class="m_-6878574263037130521mobile-hide" style="background:#f8f8f8"></td>
                 <td class="m_-6878574263037130521content" width="640" style="padding:0px;max-width:640px;background:#f8f8f8">
                     <table border="0" cellpadding="0" cellspacing="0" width="100%">            
                                     <tbody><tr>
                                         <td style="padding:24px 24px 8px 24px;max-width:592px">
             <table border="0" width="100%" cellpadding="0" cellspacing="0" style="vertical-align:middle;background-color:white" class="m_-6878574263037130521responsive-table">
                 <tbody><tr>
                     <td style="padding:16px 24px 24px 24px">
                     <table width="100%" border="0" cellspacing="0" cellpadding="0">
                         <tbody><tr>
                             <td style="font-size:21px;line-height:25px;font-weight:600;letter-spacing:-0.04em;padding:0px;width:100%">
                                     Summary
                                                     </td>
                         </tr>
                         <tr>
                             <td style="padding:12px 0px 0px 0px;line-height:20px;max-width:544px">
                                         <table border="0" cellpadding="0" cellspacing="0" style="width:100%;border-collapse:collapse!important">
         <tbody><tr>            <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap;font-weight:600;min-width:130px">Pipeline</td>
                     <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:normal;width:99%;word-break:break-word">$(Build.DefinitionName)</td>
         </tr>        <tr>
                     <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap;font-weight:600;min-width:130px">Finished</td>
                     <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:normal;width:99%;word-break:break-word">$(Get-Date -Format g) GMT+00:00</td>
         </tr>        
         <tr>                <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap;font-weight:600;min-width:130px">Requested for</td>
                         <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:normal;width:99%;word-break:break-word">$(Build.RequestedFor)</td>
         </tr>        
         <tr>            <td style="vertical-align:top;padding:10px 4px;border-bottom:none;text-align:left;white-space:nowrap;font-weight:600;min-width:130px">Reason</td>
                     <td style="vertical-align:top;padding:10px 4px;border-bottom:none;text-align:left;white-space:normal;width:99%;word-break:break-word">$(Build.Reason)</td>
         </tr>    </tbody></table>
                             </td>
                         </tr>
                     </tbody></table>
                 </td>
             </tr>
         </tbody></table>
                                         </td>
                                     </tr>
                             
                             
                                     <tr>
                                         <td style="padding:24px 24px 8px 24px;max-width:592px">
             <table border="0" width="100%" cellpadding="0" cellspacing="0" style="vertical-align:middle;background-color:white" class="m_-6878574263037130521responsive-table">
                 <tbody><tr>
                     <td style="padding:16px 24px 24px 24px">
             <table border="0" width="100%" cellpadding="0" cellspacing="0" style="vertical-align:middle;background-color:white" class="m_-6878574263037130521responsive-table">
                 <tbody><tr>
                     <td style="padding:16px 24px 24px 24px">
                     <table width="100%" border="0" cellspacing="0" cellpadding="0">
                         <tbody><tr>
                             <td style="font-size:21px;line-height:25px;font-weight:600;letter-spacing:-0.04em;padding:0px;width:100%">
                                     Commit
                                                     </td>
                         </tr>
                         <tr>
                             <td style="padding:12px 0px 0px 0px;line-height:20px;max-width:544px">
                                         <table border="0" cellpadding="0" cellspacing="0" style="width:100%;border-collapse:collapse!important">
                 <tbody><tr>
         <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap">                <a href="https://dev.azure.com/azolvedevops/43c49014-d566-49f1-a3ef-658d41d70222/_git/9ea87984-08aa-40ab-8adb-54385e62d99a/commit/$(Build.SourceVersion)" target="_blank" data-saferedirecturl="https://www.google.com/url?q=https://dev.azure.com/azolvedevops/43c49014-d566-49f1-a3ef-658d41d70222/_git/9ea87984-08aa-40ab-8adb-54385e62d99a/commit/$(Build.SourceVersion)&amp;source=gmail&amp;ust=1640769366366000&amp;usg=AOvVaw0SsVZYi2MoIYexVtLKzJjp"><span class="m_-6878574263037130521monospaced">$(Build.SourceVersion)</span></a>
         </td>            <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:normal;width:99%;word-break:break-word">
                         $(Build.SourceVersionMessage)
                         <td style="vertical-align:top;padding:10px 4px;border-bottom:solid #eaeaea 1px;text-align:left;white-space:nowrap">
                         Branch $(Build.SourceBranchName)
         </td>
         </td>            
         </div>
         </body></html>
         "@
         $secpasswd = ConvertTo-SecureString "$(mail_pass)" -AsPlainText -Force
         $cred = New-Object System.Management.Automation.PSCredential ("akash.paul@justgo.com", $secpasswd)
         Send-MailMessage -SmtpServer smtp.gmail.com -Credential $cred -UseSsl -From 'akash.paul@justgo.com' -To 'akash.paul@justgo.com' -Subject 'Patch Pipeline partially succeeded - $(Build.DefinitionName)' -Body $body -BodyAsHtml
         Continue
  
      displayName: 'Partially Succeeded email'
      enabled: true
      errorActionPreference: default
      failOnStderr: true
      ignoreLASTEXITCODE: true
      condition: eq(variables['Agent.JobStatus'], 'SucceededWithIssues')
